import { Observable } from 'rxjs';
import { HttpClient } from '@angular/common/http';
import { AccountAspect } from "../core/service";
import { RestAspect, ConfigService } from '@yukawa/chain-base-angular-client';
import { SearchResult, QueryResult, EditResult } from '@yukawa/chain-base-angular-domain';
import { AccountFilter } from '../core/filter';
import { PartnerFilter } from '../../gen/filter';
import { ContactLog, Partner, PartnerInfo, Relation } from '../../gen/domain';
export declare class AccountService extends RestAspect implements AccountAspect {
    Accounts: Account[];
    constructor(http: HttpClient, configService: ConfigService);
    queryAccount(filter: PartnerFilter): Observable<QueryResult<Partner>>;
    queryAccountsAsList(partnerType?: string, keyword?: string): Observable<Partner[]>;
    mergeAccount(partner: Partner): Observable<any>;
    loadAccount(id: string): Observable<Partner>;
    saveAccount(account: Partner, type?: "create" | "update"): Observable<any>;
    deleteAccount(id: any): Observable<EditResult>;
    newAccount(): Observable<Partner>;
    export(filter: AccountFilter | any): Observable<Blob>;
    protected formatServiceUrl(path?: string): string;
}
export declare class RelationService extends RestAspect {
    Relations: Relation[];
    constructor(http: HttpClient, configService: ConfigService);
    searchRelation(filter: any): Observable<SearchResult<Relation>>;
    queryRelation(filter: any): Observable<QueryResult<Relation>>;
    loadRelation(id: string): Observable<Relation>;
    saveRelation(relation: Relation, type?: "create" | "update"): Observable<any>;
    deleteRelation(id: any): Observable<EditResult>;
    traverseRelations(partnerId: string, role: string, traversalDir: string): Observable<PartnerInfo[]>;
    protected formatServiceUrl(path?: string): string;
}
export declare class ContactLogService extends RestAspect {
    Contacts: ContactLog[];
    constructor(http: HttpClient, configService: ConfigService);
    searchContactLog(filter: any): Observable<SearchResult<ContactLog>>;
    queryContactLog(filter: any): Observable<QueryResult<Relation>>;
    loadContactLog(id: string): Observable<ContactLog>;
    saveContactLog(contactLog: ContactLog, type?: "create" | "update"): Observable<any>;
    deleteContactLog(id: any): Observable<EditResult>;
}
