import { Injectable, Inject, forwardRef, ɵɵdefineInjectable, ɵɵinject, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { HttpHeaders, HttpClient, HttpParams, HttpClientModule } from '@angular/common/http';
import { map } from 'rxjs/operators';
import { RestAspect, ConfigService } from '@yukawa/chain-base-angular-client';
import _ from 'lodash';
import { CommonModule } from '@angular/common';
import { TranslateModule } from '@ngx-translate/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AccountService extends RestAspect {
    /**
     * @param {?} http
     * @param {?} configService
     */
    constructor(http, configService) {
        super(http, configService);
    }
    // searchAccount(filter: any): Observable<SearchResult<Partner>> {
    //     return this.search<Partner>(this.formatServiceUrl('/search'), filter);
    // }
    /**
     * @param {?} filter
     * @return {?}
     */
    queryAccount(filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    }
    /**
     * @param {?=} partnerType
     * @param {?=} keyword
     * @return {?}
     */
    queryAccountsAsList(partnerType, keyword) {
        return this.queryAccount({
            pager: { pageSize: 100, firstResult: 0 },
            keyword: keyword,
            partnerType: partnerType
        }).pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        value => value.items)));
    }
    // queryAccountsAsListWithEmptyOption(): Observable<Partner []> {
    //     console.log()
    //     return this.queryAccount({pageSize: 1000000}).pipe(map(value => {
    //         value.items.push(<Partner>{});
    //         return value.items;
    //     }));
    // }
    /**
     * @param {?} partner
     * @return {?}
     */
    mergeAccount(partner) {
        return this.edit(this.formatServiceUrl(`/merge`), partner, { method: 'post' });
    }
    /**
     * @param {?} id
     * @return {?}
     */
    loadAccount(id) {
        return this.load(`${this.formatServiceUrl('')}/?key=${id}`)
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        value => this.checkNotNull(value))));
    }
    /**
     * @param {?} account
     * @param {?=} type
     * @return {?}
     */
    saveAccount(account, type = "create") {
        return this.edit(this.formatServiceUrl(`/${type}`), account, { method: 'post' });
    }
    /**
     * @param {?} id
     * @return {?}
     */
    deleteAccount(id) {
        return this.http.delete(`${this.formatServiceUrl('')}/?key=${id}`);
    }
    /**
     * @return {?}
     */
    newAccount() {
        return this.http.post(`${this.formatServiceUrl('/new')}`, {})
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        value => this.checkNotNull(value))));
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    export(filter) {
        /** @type {?} */
        let opts = {
            headers: new HttpHeaders({
                'Content-Type': 'application/json'
                //'Accept': 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
            })
        };
        return this.download(`${this.formatServiceUrl('/export')}`, filter, opts);
    }
    /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    formatServiceUrl(path = '') {
        return this.configService.formatUrl("partnerUrl") + path;
    }
}
AccountService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AccountService.ctorParameters = () => [
    { type: HttpClient, decorators: [{ type: Inject, args: [forwardRef((/**
                     * @return {?}
                     */
                    () => HttpClient)),] }] },
    { type: ConfigService, decorators: [{ type: Inject, args: [forwardRef((/**
                     * @return {?}
                     */
                    () => ConfigService)),] }] }
];
/** @nocollapse */ AccountService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AccountService_Factory() { return new AccountService(ɵɵinject(HttpClient), ɵɵinject(ConfigService)); }, token: AccountService, providedIn: "root" });
if (false) {
    /** @type {?} */
    AccountService.prototype.Accounts;
}
class RelationService extends RestAspect {
    /**
     * @param {?} http
     * @param {?} configService
     */
    constructor(http, configService) {
        super(http, configService);
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    searchRelation(filter) {
        return this.search(this.formatServiceUrl('/search'), filter);
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    queryRelation(filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    }
    /**
     * @param {?} id
     * @return {?}
     */
    loadRelation(id) {
        return this.load(`${this.formatServiceUrl('')}/?key=${id}`)
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        value => this.checkNotNull(value))));
    }
    /**
     * @param {?} relation
     * @param {?=} type
     * @return {?}
     */
    saveRelation(relation, type = "create") {
        return this.edit(this.formatServiceUrl(`/${type}`), relation, { method: 'post' });
    }
    /**
     * @param {?} id
     * @return {?}
     */
    deleteRelation(id) {
        return this.http.delete(`${this.formatServiceUrl('')}/?key=${id}`);
    }
    /**
     * @param {?} partnerId
     * @param {?} role
     * @param {?} traversalDir
     * @return {?}
     */
    traverseRelations(partnerId, role, traversalDir) {
        return this.http.get(`${this.formatServiceUrl('/traverse')}?partnerId=${partnerId}&role=${role}&traversalDir=${traversalDir}`);
    }
    /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    formatServiceUrl(path = '') {
        return this.configService.formatUrl("relationUrl") + path;
    }
}
RelationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
RelationService.ctorParameters = () => [
    { type: HttpClient, decorators: [{ type: Inject, args: [forwardRef((/**
                     * @return {?}
                     */
                    () => HttpClient)),] }] },
    { type: ConfigService, decorators: [{ type: Inject, args: [forwardRef((/**
                     * @return {?}
                     */
                    () => ConfigService)),] }] }
];
/** @nocollapse */ RelationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function RelationService_Factory() { return new RelationService(ɵɵinject(HttpClient), ɵɵinject(ConfigService)); }, token: RelationService, providedIn: "root" });
if (false) {
    /** @type {?} */
    RelationService.prototype.Relations;
}
class ContactLogService extends RestAspect {
    /**
     * @param {?} http
     * @param {?} configService
     */
    constructor(http, configService) {
        super(http, configService, configService.formatUrl("contactLogUrl"));
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    searchContactLog(filter) {
        return this.search(this.formatServiceUrl('/search'), filter);
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    queryContactLog(filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    }
    /**
     * @param {?} id
     * @return {?}
     */
    loadContactLog(id) {
        return this.load(`${this.formatServiceUrl('')}/?key=${id}`)
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        value => this.checkNotNull(value))));
    }
    /**
     * @param {?} contactLog
     * @param {?=} type
     * @return {?}
     */
    saveContactLog(contactLog, type = "create") {
        return this.edit(this.formatServiceUrl(`/${type}`), contactLog, { method: 'post' });
    }
    /**
     * @param {?} id
     * @return {?}
     */
    deleteContactLog(id) {
        return this.http.delete(`${this.formatServiceUrl('')}/?key=${id}`);
    }
}
ContactLogService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ContactLogService.ctorParameters = () => [
    { type: HttpClient, decorators: [{ type: Inject, args: [forwardRef((/**
                     * @return {?}
                     */
                    () => HttpClient)),] }] },
    { type: ConfigService, decorators: [{ type: Inject, args: [forwardRef((/**
                     * @return {?}
                     */
                    () => ConfigService)),] }] }
];
/** @nocollapse */ ContactLogService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ContactLogService_Factory() { return new ContactLogService(ɵɵinject(HttpClient), ɵɵinject(ConfigService)); }, token: ContactLogService, providedIn: "root" });
if (false) {
    /** @type {?} */
    ContactLogService.prototype.Contacts;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const PartnerType = {
    COMPANY: "company",
    PERSON: "person",
};
/** @type {?} */
const partnerTypes = [];
for (let n in PartnerType) {
    partnerTypes.push(PartnerType[n]);
}
/**
 * @record
 */
function RelationConfig() { }
if (false) {
    /** @type {?} */
    RelationConfig.prototype.source;
    /** @type {?} */
    RelationConfig.prototype.target;
    /** @type {?} */
    RelationConfig.prototype.role;
    /** @type {?} */
    RelationConfig.prototype.relation;
    /** @type {?} */
    RelationConfig.prototype.inverseRelation;
    /** @type {?|undefined} */
    RelationConfig.prototype.perspective;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function AccountFilter() { }
if (false) {
    /** @type {?|undefined} */
    AccountFilter.prototype.keyword;
    /** @type {?} */
    AccountFilter.prototype.partnerType;
}
/**
 * @record
 */
function RelationFilter() { }
if (false) {
    /** @type {?|undefined} */
    RelationFilter.prototype.keyword;
    /** @type {?|undefined} */
    RelationFilter.prototype.partnerId;
    /** @type {?|undefined} */
    RelationFilter.prototype.partnerTargetId;
    /** @type {?|undefined} */
    RelationFilter.prototype.partnerSourceId;
    /** @type {?|undefined} */
    RelationFilter.prototype.targetOrSourceIds;
    /** @type {?|undefined} */
    RelationFilter.prototype.role;
}
/**
 * @record
 */
function ContactLogFilter() { }
if (false) {
    /** @type {?|undefined} */
    ContactLogFilter.prototype.keyword;
    /** @type {?|undefined} */
    ContactLogFilter.prototype.partnerId;
    /** @type {?|undefined} */
    ContactLogFilter.prototype.communicationChannel;
    /** @type {?|undefined} */
    ContactLogFilter.prototype.participantId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function AccountAspect() { }
if (false) {
    /** @type {?} */
    AccountAspect.prototype.Accounts;
    /**
     * @param {?} filter
     * @return {?}
     */
    AccountAspect.prototype.queryAccount = function (filter) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    AccountAspect.prototype.loadAccount = function (id, shortName) { };
    /**
     * @param {?} partner
     * @return {?}
     */
    AccountAspect.prototype.saveAccount = function (partner) { };
    /**
     * @param {?} id
     * @return {?}
     */
    AccountAspect.prototype.deleteAccount = function (id) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    AccountAspect.prototype.newAccount = function (id, shortName) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const withType = (/**
 * @param {?} partner
 * @param {?} type
 * @return {?}
 */
(partner, type) => partner.partnerType === type);
/** @type {?} */
const withId = (/**
 * @param {?} partner
 * @param {?} id
 * @return {?}
 */
(partner, id) => partner.partnerId === id);
/** @type {?} */
const sortByCompanyName = (/**
 * @param {?} p1
 * @param {?} p2
 * @return {?}
 */
(p1, p2) => {
    if (p1.companyName && p2.companyName) {
        return p1.companyName.localeCompare(p2.companyName);
    }
    return 0;
});
/** @type {?} */
const sortByLastName = (/**
 * @param {?} p1
 * @param {?} p2
 * @return {?}
 */
(p1, p2) => {
    if (p1.lastName && p2.lastName) {
        return p1.lastName.localeCompare(p2.lastName);
    }
    return 0;
});
class AccountUtilities {
    /**
     * @param {?} partners
     * @param {?} partnerId
     * @return {?}
     */
    static getPartnerById(partners, partnerId) {
        /** @type {?} */
        const ifExist = partners.find((/**
         * @param {?} val
         * @return {?}
         */
        val => val.partnerId === partnerId));
        return ifExist;
    }
    /**
     * @param {?} partner
     * @param {?=} partnerType
     * @return {?}
     */
    static getDisplayName(partner, partnerType) {
        if (partner && partner.partnerType) {
            return partner.partnerType === PartnerType.COMPANY ? partner.companyName : partner.firstName + ' ' + partner.lastName;
        }
        if (partnerType) {
            return partnerType === PartnerType.COMPANY.toString() ? partner.companyName : partner.firstName + ' ' + partner.lastName;
        }
        return "";
    }
    /**
     * @param {?} partner1
     * @param {?} partner2
     * @return {?}
     */
    static compareWith(partner1, partner2) {
        return partner1 && partner2 ? partner1.partnerId === partner2.partnerId : -1;
    }
    /**
     * @param {?} partner
     * @return {?}
     */
    static buildPartnerInfo(partner) {
        /** @type {?} */
        const subset = ((/**
         * @param {?} __0
         * @return {?}
         */
        ({ companyName, email, firstName, lastName, partnerId, shortName }) => ({
            companyName,
            email,
            firstName,
            lastName,
            partnerId,
            shortName
        })));
        return subset(partner);
    }
    /**
     * @param {?} accounts
     * @param {?} subject
     * @param {?} filterCtrl
     * @return {?}
     */
    static filterAccounts(accounts, subject, filterCtrl) {
        if (!accounts) {
            return;
        }
        // get the search keyword
        /** @type {?} */
        let search = filterCtrl.value;
        if (!search) {
            subject.next(accounts.slice());
            return;
        }
        else {
            search = search.toLowerCase();
        }
        // filter the accounts
        subject.next(accounts.filter((/**
         * @param {?} account
         * @return {?}
         */
        account => {
            if (account.companyName) {
                return account.companyName.toLowerCase().indexOf(search) > -1;
            }
            if (account.firstName && account.lastName) {
                return account.firstName.toLowerCase().indexOf(search) > -1 || account.lastName.toLowerCase().indexOf(search) > -1;
            }
        })));
    }
}
if (false) {
    /** @type {?} */
    AccountUtilities.prototype.partner;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AddressUtils {
    constructor() {
    }
    /**
     * @param {?} address
     * @param {?} type
     * @return {?}
     */
    static findAddressByType(address, type) {
        /** @type {?} */
        const _address = address.filter((/**
         * @param {?} val
         * @return {?}
         */
        val => val.type != null)).find((/**
         * @param {?} val
         * @return {?}
         */
        val => val.type === this.TYPE_INVOICE));
        return _address;
    }
    /**
     * @param {?} fb
     * @param {?=} initial
     * @param {?=} validators
     * @return {?}
     */
    static getFormGroup(fb, initial, validators) {
        /** @type {?} */
        const group = fb.group({
            type: [null, null],
            street: [null, null],
            houseNumber: [null, null],
            countryCode: [null, null],
            city: [null, null],
            zipCode: [null, null],
            desc: [null, null]
        });
        if (initial) {
            group.patchValue(initial);
        }
        return group;
    }
    /**
     * @param {?} fa
     * @param {?} fb
     * @param {?=} initial
     * @return {?}
     */
    static addAddressToFormArray(fa, fb, initial) {
        /** @type {?} */
        let formArray = (/** @type {?} */ (fa));
        formArray.push(this.getFormGroup(fb, initial));
    }
    /**
     * @param {?} fa
     * @param {?} fb
     * @param {?=} initial
     * @return {?}
     */
    static addAndGetAddress(fa, fb, initial) {
        /** @type {?} */
        let formArray = (/** @type {?} */ (fa));
        /** @type {?} */
        let group = this.getFormGroup(fb, initial);
        formArray.push(group);
        return group;
    }
}
AddressUtils.TYPE_INVOICE = "INVOICE";
if (false) {
    /** @type {?} */
    AddressUtils.TYPE_INVOICE;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const PartnerType$1 = {
    COMPANY: "company",
    PERSON: "person",
};
/** @type {?} */
const partnerTypes$1 = [];
for (let n in PartnerType$1) {
    partnerTypes$1.push(PartnerType$1[n]);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// configuration of possible roles in a relation
// the convention is that the relation represents the natural understanding of: source - role - target
/** @type {?} */
const relationsConfig = [
    {
        source: PartnerType$1.COMPANY,
        target: PartnerType$1.COMPANY,
        role: "isHoldingOf",
        relation: "Is holding of",
        inverseRelation: "Is subsidiary of"
    },
    {
        source: PartnerType$1.PERSON,
        target: PartnerType$1.COMPANY,
        relation: "is employee of",
        inverseRelation: "employs",
        role: "isEmployeeOf"
    },
    {
        source: PartnerType$1.COMPANY,
        target: PartnerType$1.COMPANY,
        relation: "is supplier of",
        inverseRelation: "has supplier",
        role: "isSupplierOf",
    },
];
/** @enum {string} */
const RelationRole = {
    HOLDING_OF: "isHoldingOf",
    EMPLOYEE_OF: "isEmployeeOf",
    SUPPLIER_OF: "isSupplierOf",
};
/** @type {?} */
const relationRoles = [];
for (let n in RelationRole) {
    relationRoles.push(PartnerType$1[n]);
}
class RelationConfigService {
    constructor() {
    }
    // -----------------------------------------------------------------------------------------------------
    // @ Utility Methods
    // -----------------------------------------------------------------------------------------------------
    /**
     *
     * @param {?} type1
     * @param {?} type2
     * @return {?} all relation configs where type1 -> type2 or type2 -> type1
     */
    static getRelationConfigsUndirected(type1, type2) {
        /** @type {?} */
        const _config = relationsConfig.filter(((/**
         * @param {?} value
         * @return {?}
         */
        value => (value.source === type1 && value.target === type2) ||
            (value.source === type2 && value.target === type1))));
        return _config;
    }
    /**
     *
     * @param {?} source
     * @param {?} target
     * @return {?} all relation configs that exist from source type to target type
     */
    static getRelationConfigsDirected(source, target) {
        /** @type {?} */
        const _relationConfig = relationsConfig.filter(((/**
         * @param {?} value
         * @return {?}
         */
        value => (value.source === source && value.target === target))));
        return _relationConfig;
    }
    /**
     *
     * @param {?} role
     * @return {?} the unique RelationConfig for a role
     */
    static getRelationConfigForRole(role) {
        /** @type {?} */
        const _relationConfig = relationsConfig.filter((/**
         * @param {?} value
         * @return {?}
         */
        value => value.role === role)).find((/**
         * @param {?} x
         * @return {?}
         */
        x => x !== undefined));
        return _relationConfig;
    }
    /**
     *
     * @param {?} rel relation
     * @param {?} partnerId the partner that appears either as source or as target in rel
     * @return {?} returns the relation designation
     */
    static getDisplayedRelation(rel, partnerId) {
        /** @type {?} */
        let config = this.getRelationConfigForRole(rel.role);
        return rel.sourcePartner.partnerId === partnerId ? config.relation : config.inverseRelation;
    }
    /**
     *
     * @param {?} type
     * @return {?} all configurations including type either as source or target
     */
    static getRelationConfigsIncludingType(type) {
        /** @type {?} */
        let configs = relationsConfig.filter((/**
         * @param {?} value
         * @return {?}
         */
        value => value.source === type || value.target === type));
        for (let config of configs) {
            if (config.target === type) {
                config.perspective = 'target';
            }
            else {
                config.perspective = 'source';
            }
        }
        return configs;
    }
    /**
     *
     * @param {?} type
     * @return {?} all configurations including type either source
     */
    static getRelationConfigsIncludingTypeAsSource(type) {
        /** @type {?} */
        let res = _.cloneDeep((relationsConfig.filter((/**
         * @param {?} value
         * @return {?}
         */
        value => value.source === type))));
        for (let val of res) {
            val.perspective = 'source';
        }
        return res;
    }
    /**
     *
     * @param {?} type
     * @return {?} all configurations including type either source
     */
    static getRelationConfigsIncludingTypeAsTarget(type) {
        /** @type {?} */
        let res = _.cloneDeep(relationsConfig.filter((/**
         * @param {?} value
         * @return {?}
         */
        value => value.target === type)));
        for (let val of res) {
            val.perspective = 'target';
        }
        return res;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Billing <br/>
 * @record
 */
function Billing() { }
if (false) {
    /** @type {?|undefined} */
    Billing.prototype.bankAccount;
    /** @type {?|undefined} */
    Billing.prototype.invoiceText;
    /** @type {?|undefined} */
    Billing.prototype.notes;
    /** @type {?|undefined} */
    Billing.prototype.paymentConditions;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.ContactLog <br/>
 * @record
 */
function ContactLog() { }
if (false) {
    /** @type {?|undefined} */
    ContactLog.prototype.change;
    /**
     * 	values: email, phone<br/>
     * \@example email
     * @type {?|undefined}
     */
    ContactLog.prototype.communicationChannel;
    /** @type {?|undefined} */
    ContactLog.prototype.contactLogId;
    /** @type {?|undefined} */
    ContactLog.prototype.created;
    /**
     * @deprecated
     * @type {?|undefined}
     */
    ContactLog.prototype.dateRange;
    /** @type {?|undefined} */
    ContactLog.prototype.duration;
    /** @type {?|undefined} */
    ContactLog.prototype.info;
    /** @type {?|undefined} */
    ContactLog.prototype.location;
    /** @type {?|undefined} */
    ContactLog.prototype.notes;
    /** @type {?|undefined} */
    ContactLog.prototype.orgId;
    /** @type {?|undefined} */
    ContactLog.prototype.participants;
    /** @type {?|undefined} */
    ContactLog.prototype.projectId;
    /**
     * 	values: new, pending, done, archived<br/>
     * \@example new
     * @type {?|undefined}
     */
    ContactLog.prototype.status;
    /** @type {?|undefined} */
    ContactLog.prototype.taskId;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Participant <br/>
 * @record
 */
function Participant() { }
if (false) {
    /** @type {?|undefined} */
    Participant.prototype.participantId;
    /** @type {?|undefined} */
    Participant.prototype.role;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Partner <br/>
 * @record
 */
function Partner() { }
if (false) {
    /** @type {?|undefined} */
    Partner.prototype.billing;
    /** @type {?|undefined} */
    Partner.prototype.classification;
    /** @type {?|undefined} */
    Partner.prototype.displayName;
    /** @type {?|undefined} */
    Partner.prototype.jobDesc;
    /** @type {?|undefined} */
    Partner.prototype.masterContractAvailable;
    /** @type {?|undefined} */
    Partner.prototype.nda;
    /** @type {?|undefined} */
    Partner.prototype.orgId;
    /** @type {?|undefined} */
    Partner.prototype.partnerId;
    /**
     * 	values: person, company<br/>
     * \@example person
     * @type {?|undefined}
     */
    Partner.prototype.partnerType;
    /**
     * 	values: email, phone<br/>
     * \@example email
     * @type {?|undefined}
     */
    Partner.prototype.preferredCommunicationChannel;
    /**
     * 	values: active, inactive, blocked<br/>
     * @type {?|undefined}
     */
    Partner.prototype.status;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.PartnerInfo <br/>
 * @record
 */
function PartnerInfo() { }
if (false) {
    /** @type {?|undefined} */
    PartnerInfo.prototype.classification;
    /** @type {?|undefined} */
    PartnerInfo.prototype.companyName;
    /** @type {?|undefined} */
    PartnerInfo.prototype.email;
    /** @type {?|undefined} */
    PartnerInfo.prototype.firstName;
    /** @type {?|undefined} */
    PartnerInfo.prototype.lastName;
    /** @type {?|undefined} */
    PartnerInfo.prototype.partnerId;
    /** @type {?|undefined} */
    PartnerInfo.prototype.partnerType;
    /** @type {?|undefined} */
    PartnerInfo.prototype.shortName;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Relation <br/>
 * @record
 */
function Relation() { }
if (false) {
    /** @type {?|undefined} */
    Relation.prototype.change;
    /**
     * \@example Lead, Engineer
     * @type {?|undefined}
     */
    Relation.prototype.classifier;
    /** @type {?|undefined} */
    Relation.prototype.created;
    /** @type {?|undefined} */
    Relation.prototype.orgId;
    /** @type {?|undefined} */
    Relation.prototype.relationId;
    /**
     * 	values: customer, employee, employer<br/>
     * \@example customer
     * @type {?|undefined}
     */
    Relation.prototype.role;
    /** @type {?|undefined} */
    Relation.prototype.sourcePartner;
    /** @type {?|undefined} */
    Relation.prototype.targetPartner;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Reminder <br/>
 * @record
 */
function Reminder() { }
if (false) {
    /** @type {?|undefined} */
    Reminder.prototype.change;
    /**
     * 	values: email, phone<br/>
     * \@example email
     * @type {?|undefined}
     */
    Reminder.prototype.communicationChannel;
    /** @type {?|undefined} */
    Reminder.prototype.created;
    /** @type {?|undefined} */
    Reminder.prototype.dueDate;
    /** @type {?|undefined} */
    Reminder.prototype.notes;
    /** @type {?|undefined} */
    Reminder.prototype.orgId;
    /** @type {?|undefined} */
    Reminder.prototype.reminderId;
    /** @type {?|undefined} */
    Reminder.prototype.reminderPartnerId;
    /**
     * 	values: new, pending, done, archived<br/>
     * \@example new
     * @type {?|undefined}
     */
    Reminder.prototype.status;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.filter.PartnerFilter <br/>
 * @record
 */
function PartnerFilter() { }
if (false) {
    /** @type {?|undefined} */
    PartnerFilter.prototype.classification;
    /** @type {?|undefined} */
    PartnerFilter.prototype.companyName;
    /** @type {?|undefined} */
    PartnerFilter.prototype.email;
    /** @type {?|undefined} */
    PartnerFilter.prototype.firstName;
    /** @type {?|undefined} */
    PartnerFilter.prototype.lastName;
    /** @type {?|undefined} */
    PartnerFilter.prototype.mobile;
    /** @type {?|undefined} */
    PartnerFilter.prototype.partnerId;
    /** @type {?|undefined} */
    PartnerFilter.prototype.partnerType;
    /** @type {?|undefined} */
    PartnerFilter.prototype.phoneNumber;
    /** @type {?|undefined} */
    PartnerFilter.prototype.preferredCommunicationChannel;
    /** @type {?|undefined} */
    PartnerFilter.prototype.role;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.filter.ReminderFilter <br/>
 * @record
 */
function ReminderFilter() { }
if (false) {
    /** @type {?|undefined} */
    ReminderFilter.prototype.communicationChannel;
    /** @type {?|undefined} */
    ReminderFilter.prototype.dueDateRange;
    /** @type {?|undefined} */
    ReminderFilter.prototype.notes;
    /** @type {?|undefined} */
    ReminderFilter.prototype.reminderId;
    /** @type {?|undefined} */
    ReminderFilter.prototype.reminderPartnerId;
    /** @type {?|undefined} */
    ReminderFilter.prototype.status;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.partner.service.rest.ContactLogRest <br/>
 */
class ContactLogRest {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
}
ContactLogRest.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ContactLogRest.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    ContactLogRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.partner.service.rest.PartnerRest <br/>
 */
class PartnerRest {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
}
PartnerRest.decorators = [
    { type: Injectable }
];
/** @nocollapse */
PartnerRest.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    PartnerRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.partner.service.rest.RelationRest <br/>
 */
class RelationRest {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
    /**
     * @param {?} partnerId
     * @param {?} role
     * @param {?} traversalDir
     * @return {?}
     */
    traverseRelations(partnerId, role, traversalDir) {
        /** @type {?} */
        const queryParamsList = [];
        queryParamsList.push({ name: 'partnerId', value: partnerId });
        queryParamsList.push({ name: 'role', value: role });
        queryParamsList.push({ name: 'traversalDir', value: traversalDir });
        /** @type {?} */
        let params = new HttpParams();
        for (const queryParam of queryParamsList) {
            params = params.append(queryParam.name, queryParam.value);
        }
        return this.httpService.post('/relations/traverse', null, { params });
    }
}
RelationRest.decorators = [
    { type: Injectable }
];
/** @nocollapse */
RelationRest.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    RelationRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.partner.service.rest.ReminderRest <br/>
 */
class ReminderRest {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
}
ReminderRest.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ReminderRest.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /** @type {?} */
    ReminderRest.prototype.httpService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@toDo * [ww] 'Account' => Partner
 * @deprecated
 * @record
 */
function PartnerAspect() { }
if (false) {
    /**
     * @param {?} filter
     * @return {?}
     */
    PartnerAspect.prototype.queryAccount = function (filter) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    PartnerAspect.prototype.loadAccount = function (id, shortName) { };
    /**
     * @param {?} partner
     * @return {?}
     */
    PartnerAspect.prototype.saveAccount = function (partner) { };
    /**
     * @param {?} id
     * @return {?}
     */
    PartnerAspect.prototype.deleteAccount = function (id) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    PartnerAspect.prototype.newAccount = function (id, shortName) { };
    /**
     * @param {?} filter
     * @return {?}
     */
    PartnerAspect.prototype.export = function (filter) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// services
class CRMCoreModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: CRMCoreModule,
            providers: [
                AccountService, ContactLogService, RelationService, RelationConfigService
            ]
        };
    }
}
CRMCoreModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    HttpClientModule,
                    TranslateModule.forChild()
                ],
                declarations: [],
                exports: [],
                providers: [],
                entryComponents: [],
                schemas: [CUSTOM_ELEMENTS_SCHEMA]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AccountService, AccountUtilities, AddressUtils, CRMCoreModule, ContactLogRest, ContactLogService, PartnerRest, PartnerType, RelationConfigService, RelationRest, RelationRole, RelationService, ReminderRest, partnerTypes, relationRoles, relationsConfig, sortByCompanyName, sortByLastName, withId, withType, PartnerType$1 as ɵa };
//# sourceMappingURL=yukawa-chain-crm-angular-core.js.map
