import { __extends, __values } from 'tslib';
import { Injectable, Inject, forwardRef, ɵɵdefineInjectable, ɵɵinject, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { HttpHeaders, HttpClient, HttpParams, HttpClientModule } from '@angular/common/http';
import { map } from 'rxjs/operators';
import { ConfigService, RestAspect } from '@yukawa/chain-base-angular-client';
import _ from 'lodash';
import { CommonModule } from '@angular/common';
import { TranslateModule } from '@ngx-translate/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccountService = /** @class */ (function (_super) {
    __extends(AccountService, _super);
    function AccountService(http, configService) {
        return _super.call(this, http, configService) || this;
    }
    // searchAccount(filter: any): Observable<SearchResult<Partner>> {
    //     return this.search<Partner>(this.formatServiceUrl('/search'), filter);
    // }
    // searchAccount(filter: any): Observable<SearchResult<Partner>> {
    //     return this.search<Partner>(this.formatServiceUrl('/search'), filter);
    // }
    /**
     * @param {?} filter
     * @return {?}
     */
    AccountService.prototype.queryAccount = 
    // searchAccount(filter: any): Observable<SearchResult<Partner>> {
    //     return this.search<Partner>(this.formatServiceUrl('/search'), filter);
    // }
    /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    };
    /**
     * @param {?=} partnerType
     * @param {?=} keyword
     * @return {?}
     */
    AccountService.prototype.queryAccountsAsList = /**
     * @param {?=} partnerType
     * @param {?=} keyword
     * @return {?}
     */
    function (partnerType, keyword) {
        return this.queryAccount({
            pager: { pageSize: 100, firstResult: 0 },
            keyword: keyword,
            partnerType: partnerType
        }).pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return value.items; })));
    };
    // queryAccountsAsListWithEmptyOption(): Observable<Partner []> {
    //     console.log()
    //     return this.queryAccount({pageSize: 1000000}).pipe(map(value => {
    //         value.items.push(<Partner>{});
    //         return value.items;
    //     }));
    // }
    // queryAccountsAsListWithEmptyOption(): Observable<Partner []> {
    //     console.log()
    //     return this.queryAccount({pageSize: 1000000}).pipe(map(value => {
    //         value.items.push(<Partner>{});
    //         return value.items;
    //     }));
    // }
    /**
     * @param {?} partner
     * @return {?}
     */
    AccountService.prototype.mergeAccount = 
    // queryAccountsAsListWithEmptyOption(): Observable<Partner []> {
    //     console.log()
    //     return this.queryAccount({pageSize: 1000000}).pipe(map(value => {
    //         value.items.push(<Partner>{});
    //         return value.items;
    //     }));
    // }
    /**
     * @param {?} partner
     * @return {?}
     */
    function (partner) {
        return this.edit(this.formatServiceUrl("/merge"), partner, { method: 'post' });
    };
    /**
     * @param {?} id
     * @return {?}
     */
    AccountService.prototype.loadAccount = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        var _this = this;
        return this.load(this.formatServiceUrl('') + "/?key=" + id)
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return _this.checkNotNull(value); })));
    };
    /**
     * @param {?} account
     * @param {?=} type
     * @return {?}
     */
    AccountService.prototype.saveAccount = /**
     * @param {?} account
     * @param {?=} type
     * @return {?}
     */
    function (account, type) {
        if (type === void 0) { type = "create"; }
        return this.edit(this.formatServiceUrl("/" + type), account, { method: 'post' });
    };
    /**
     * @param {?} id
     * @return {?}
     */
    AccountService.prototype.deleteAccount = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
    };
    /**
     * @return {?}
     */
    AccountService.prototype.newAccount = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.http.post("" + this.formatServiceUrl('/new'), {})
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return _this.checkNotNull(value); })));
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    AccountService.prototype.export = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var opts = {
            headers: new HttpHeaders({
                'Content-Type': 'application/json'
                //'Accept': 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
            })
        };
        return this.download("" + this.formatServiceUrl('/export'), filter, opts);
    };
    /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    AccountService.prototype.formatServiceUrl = /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    function (path) {
        if (path === void 0) { path = ''; }
        return this.configService.formatUrl("partnerUrl") + path;
    };
    AccountService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AccountService.ctorParameters = function () { return [
        { type: HttpClient, decorators: [{ type: Inject, args: [forwardRef((/**
                         * @return {?}
                         */
                        function () { return HttpClient; })),] }] },
        { type: ConfigService, decorators: [{ type: Inject, args: [forwardRef((/**
                         * @return {?}
                         */
                        function () { return ConfigService; })),] }] }
    ]; };
    /** @nocollapse */ AccountService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AccountService_Factory() { return new AccountService(ɵɵinject(HttpClient), ɵɵinject(ConfigService)); }, token: AccountService, providedIn: "root" });
    return AccountService;
}(RestAspect));
if (false) {
    /** @type {?} */
    AccountService.prototype.Accounts;
}
var RelationService = /** @class */ (function (_super) {
    __extends(RelationService, _super);
    function RelationService(http, configService) {
        return _super.call(this, http, configService) || this;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    RelationService.prototype.searchRelation = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.search(this.formatServiceUrl('/search'), filter);
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    RelationService.prototype.queryRelation = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    };
    /**
     * @param {?} id
     * @return {?}
     */
    RelationService.prototype.loadRelation = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        var _this = this;
        return this.load(this.formatServiceUrl('') + "/?key=" + id)
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return _this.checkNotNull(value); })));
    };
    /**
     * @param {?} relation
     * @param {?=} type
     * @return {?}
     */
    RelationService.prototype.saveRelation = /**
     * @param {?} relation
     * @param {?=} type
     * @return {?}
     */
    function (relation, type) {
        if (type === void 0) { type = "create"; }
        return this.edit(this.formatServiceUrl("/" + type), relation, { method: 'post' });
    };
    /**
     * @param {?} id
     * @return {?}
     */
    RelationService.prototype.deleteRelation = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
    };
    /**
     * @param {?} partnerId
     * @param {?} role
     * @param {?} traversalDir
     * @return {?}
     */
    RelationService.prototype.traverseRelations = /**
     * @param {?} partnerId
     * @param {?} role
     * @param {?} traversalDir
     * @return {?}
     */
    function (partnerId, role, traversalDir) {
        return this.http.get(this.formatServiceUrl('/traverse') + "?partnerId=" + partnerId + "&role=" + role + "&traversalDir=" + traversalDir);
    };
    /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    RelationService.prototype.formatServiceUrl = /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    function (path) {
        if (path === void 0) { path = ''; }
        return this.configService.formatUrl("relationUrl") + path;
    };
    RelationService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    RelationService.ctorParameters = function () { return [
        { type: HttpClient, decorators: [{ type: Inject, args: [forwardRef((/**
                         * @return {?}
                         */
                        function () { return HttpClient; })),] }] },
        { type: ConfigService, decorators: [{ type: Inject, args: [forwardRef((/**
                         * @return {?}
                         */
                        function () { return ConfigService; })),] }] }
    ]; };
    /** @nocollapse */ RelationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function RelationService_Factory() { return new RelationService(ɵɵinject(HttpClient), ɵɵinject(ConfigService)); }, token: RelationService, providedIn: "root" });
    return RelationService;
}(RestAspect));
if (false) {
    /** @type {?} */
    RelationService.prototype.Relations;
}
var ContactLogService = /** @class */ (function (_super) {
    __extends(ContactLogService, _super);
    function ContactLogService(http, configService) {
        return _super.call(this, http, configService, configService.formatUrl("contactLogUrl")) || this;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    ContactLogService.prototype.searchContactLog = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.search(this.formatServiceUrl('/search'), filter);
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    ContactLogService.prototype.queryContactLog = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.query(this.formatServiceUrl('/query'), filter);
    };
    /**
     * @param {?} id
     * @return {?}
     */
    ContactLogService.prototype.loadContactLog = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        var _this = this;
        return this.load(this.formatServiceUrl('') + "/?key=" + id)
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return _this.checkNotNull(value); })));
    };
    /**
     * @param {?} contactLog
     * @param {?=} type
     * @return {?}
     */
    ContactLogService.prototype.saveContactLog = /**
     * @param {?} contactLog
     * @param {?=} type
     * @return {?}
     */
    function (contactLog, type) {
        if (type === void 0) { type = "create"; }
        return this.edit(this.formatServiceUrl("/" + type), contactLog, { method: 'post' });
    };
    /**
     * @param {?} id
     * @return {?}
     */
    ContactLogService.prototype.deleteContactLog = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
    };
    ContactLogService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ContactLogService.ctorParameters = function () { return [
        { type: HttpClient, decorators: [{ type: Inject, args: [forwardRef((/**
                         * @return {?}
                         */
                        function () { return HttpClient; })),] }] },
        { type: ConfigService, decorators: [{ type: Inject, args: [forwardRef((/**
                         * @return {?}
                         */
                        function () { return ConfigService; })),] }] }
    ]; };
    /** @nocollapse */ ContactLogService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ContactLogService_Factory() { return new ContactLogService(ɵɵinject(HttpClient), ɵɵinject(ConfigService)); }, token: ContactLogService, providedIn: "root" });
    return ContactLogService;
}(RestAspect));
if (false) {
    /** @type {?} */
    ContactLogService.prototype.Contacts;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var PartnerType = {
    COMPANY: "company",
    PERSON: "person",
};
/** @type {?} */
var partnerTypes = [];
for (var n in PartnerType) {
    partnerTypes.push(PartnerType[n]);
}
/**
 * @record
 */
function RelationConfig() { }
if (false) {
    /** @type {?} */
    RelationConfig.prototype.source;
    /** @type {?} */
    RelationConfig.prototype.target;
    /** @type {?} */
    RelationConfig.prototype.role;
    /** @type {?} */
    RelationConfig.prototype.relation;
    /** @type {?} */
    RelationConfig.prototype.inverseRelation;
    /** @type {?|undefined} */
    RelationConfig.prototype.perspective;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function AccountFilter() { }
if (false) {
    /** @type {?|undefined} */
    AccountFilter.prototype.keyword;
    /** @type {?} */
    AccountFilter.prototype.partnerType;
}
/**
 * @record
 */
function RelationFilter() { }
if (false) {
    /** @type {?|undefined} */
    RelationFilter.prototype.keyword;
    /** @type {?|undefined} */
    RelationFilter.prototype.partnerId;
    /** @type {?|undefined} */
    RelationFilter.prototype.partnerTargetId;
    /** @type {?|undefined} */
    RelationFilter.prototype.partnerSourceId;
    /** @type {?|undefined} */
    RelationFilter.prototype.targetOrSourceIds;
    /** @type {?|undefined} */
    RelationFilter.prototype.role;
}
/**
 * @record
 */
function ContactLogFilter() { }
if (false) {
    /** @type {?|undefined} */
    ContactLogFilter.prototype.keyword;
    /** @type {?|undefined} */
    ContactLogFilter.prototype.partnerId;
    /** @type {?|undefined} */
    ContactLogFilter.prototype.communicationChannel;
    /** @type {?|undefined} */
    ContactLogFilter.prototype.participantId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function AccountAspect() { }
if (false) {
    /** @type {?} */
    AccountAspect.prototype.Accounts;
    /**
     * @param {?} filter
     * @return {?}
     */
    AccountAspect.prototype.queryAccount = function (filter) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    AccountAspect.prototype.loadAccount = function (id, shortName) { };
    /**
     * @param {?} partner
     * @return {?}
     */
    AccountAspect.prototype.saveAccount = function (partner) { };
    /**
     * @param {?} id
     * @return {?}
     */
    AccountAspect.prototype.deleteAccount = function (id) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    AccountAspect.prototype.newAccount = function (id, shortName) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var withType = (/**
 * @param {?} partner
 * @param {?} type
 * @return {?}
 */
function (partner, type) { return partner.partnerType === type; });
/** @type {?} */
var withId = (/**
 * @param {?} partner
 * @param {?} id
 * @return {?}
 */
function (partner, id) { return partner.partnerId === id; });
/** @type {?} */
var sortByCompanyName = (/**
 * @param {?} p1
 * @param {?} p2
 * @return {?}
 */
function (p1, p2) {
    if (p1.companyName && p2.companyName) {
        return p1.companyName.localeCompare(p2.companyName);
    }
    return 0;
});
/** @type {?} */
var sortByLastName = (/**
 * @param {?} p1
 * @param {?} p2
 * @return {?}
 */
function (p1, p2) {
    if (p1.lastName && p2.lastName) {
        return p1.lastName.localeCompare(p2.lastName);
    }
    return 0;
});
var AccountUtilities = /** @class */ (function () {
    function AccountUtilities() {
    }
    /**
     * @param {?} partners
     * @param {?} partnerId
     * @return {?}
     */
    AccountUtilities.getPartnerById = /**
     * @param {?} partners
     * @param {?} partnerId
     * @return {?}
     */
    function (partners, partnerId) {
        /** @type {?} */
        var ifExist = partners.find((/**
         * @param {?} val
         * @return {?}
         */
        function (val) { return val.partnerId === partnerId; }));
        return ifExist;
    };
    /**
     * @param {?} partner
     * @param {?=} partnerType
     * @return {?}
     */
    AccountUtilities.getDisplayName = /**
     * @param {?} partner
     * @param {?=} partnerType
     * @return {?}
     */
    function (partner, partnerType) {
        if (partner && partner.partnerType) {
            return partner.partnerType === PartnerType.COMPANY ? partner.companyName : partner.firstName + ' ' + partner.lastName;
        }
        if (partnerType) {
            return partnerType === PartnerType.COMPANY.toString() ? partner.companyName : partner.firstName + ' ' + partner.lastName;
        }
        return "";
    };
    /**
     * @param {?} partner1
     * @param {?} partner2
     * @return {?}
     */
    AccountUtilities.compareWith = /**
     * @param {?} partner1
     * @param {?} partner2
     * @return {?}
     */
    function (partner1, partner2) {
        return partner1 && partner2 ? partner1.partnerId === partner2.partnerId : -1;
    };
    /**
     * @param {?} partner
     * @return {?}
     */
    AccountUtilities.buildPartnerInfo = /**
     * @param {?} partner
     * @return {?}
     */
    function (partner) {
        /** @type {?} */
        var subset = ((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var companyName = _a.companyName, email = _a.email, firstName = _a.firstName, lastName = _a.lastName, partnerId = _a.partnerId, shortName = _a.shortName;
            return ({
                companyName: companyName,
                email: email,
                firstName: firstName,
                lastName: lastName,
                partnerId: partnerId,
                shortName: shortName
            });
        }));
        return subset(partner);
    };
    /**
     * @param {?} accounts
     * @param {?} subject
     * @param {?} filterCtrl
     * @return {?}
     */
    AccountUtilities.filterAccounts = /**
     * @param {?} accounts
     * @param {?} subject
     * @param {?} filterCtrl
     * @return {?}
     */
    function (accounts, subject, filterCtrl) {
        if (!accounts) {
            return;
        }
        // get the search keyword
        /** @type {?} */
        var search = filterCtrl.value;
        if (!search) {
            subject.next(accounts.slice());
            return;
        }
        else {
            search = search.toLowerCase();
        }
        // filter the accounts
        subject.next(accounts.filter((/**
         * @param {?} account
         * @return {?}
         */
        function (account) {
            if (account.companyName) {
                return account.companyName.toLowerCase().indexOf(search) > -1;
            }
            if (account.firstName && account.lastName) {
                return account.firstName.toLowerCase().indexOf(search) > -1 || account.lastName.toLowerCase().indexOf(search) > -1;
            }
        })));
    };
    return AccountUtilities;
}());
if (false) {
    /** @type {?} */
    AccountUtilities.prototype.partner;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AddressUtils = /** @class */ (function () {
    function AddressUtils() {
    }
    /**
     * @param {?} address
     * @param {?} type
     * @return {?}
     */
    AddressUtils.findAddressByType = /**
     * @param {?} address
     * @param {?} type
     * @return {?}
     */
    function (address, type) {
        var _this = this;
        /** @type {?} */
        var _address = address.filter((/**
         * @param {?} val
         * @return {?}
         */
        function (val) { return val.type != null; })).find((/**
         * @param {?} val
         * @return {?}
         */
        function (val) { return val.type === _this.TYPE_INVOICE; }));
        return _address;
    };
    /**
     * @param {?} fb
     * @param {?=} initial
     * @param {?=} validators
     * @return {?}
     */
    AddressUtils.getFormGroup = /**
     * @param {?} fb
     * @param {?=} initial
     * @param {?=} validators
     * @return {?}
     */
    function (fb, initial, validators) {
        /** @type {?} */
        var group = fb.group({
            type: [null, null],
            street: [null, null],
            houseNumber: [null, null],
            countryCode: [null, null],
            city: [null, null],
            zipCode: [null, null],
            desc: [null, null]
        });
        if (initial) {
            group.patchValue(initial);
        }
        return group;
    };
    /**
     * @param {?} fa
     * @param {?} fb
     * @param {?=} initial
     * @return {?}
     */
    AddressUtils.addAddressToFormArray = /**
     * @param {?} fa
     * @param {?} fb
     * @param {?=} initial
     * @return {?}
     */
    function (fa, fb, initial) {
        /** @type {?} */
        var formArray = (/** @type {?} */ (fa));
        formArray.push(this.getFormGroup(fb, initial));
    };
    /**
     * @param {?} fa
     * @param {?} fb
     * @param {?=} initial
     * @return {?}
     */
    AddressUtils.addAndGetAddress = /**
     * @param {?} fa
     * @param {?} fb
     * @param {?=} initial
     * @return {?}
     */
    function (fa, fb, initial) {
        /** @type {?} */
        var formArray = (/** @type {?} */ (fa));
        /** @type {?} */
        var group = this.getFormGroup(fb, initial);
        formArray.push(group);
        return group;
    };
    AddressUtils.TYPE_INVOICE = "INVOICE";
    return AddressUtils;
}());
if (false) {
    /** @type {?} */
    AddressUtils.TYPE_INVOICE;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var PartnerType$1 = {
    COMPANY: "company",
    PERSON: "person",
};
/** @type {?} */
var partnerTypes$1 = [];
for (var n$1 in PartnerType$1) {
    partnerTypes$1.push(PartnerType$1[n$1]);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// configuration of possible roles in a relation
// the convention is that the relation represents the natural understanding of: source - role - target
/** @type {?} */
var relationsConfig = [
    {
        source: PartnerType$1.COMPANY,
        target: PartnerType$1.COMPANY,
        role: "isHoldingOf",
        relation: "Is holding of",
        inverseRelation: "Is subsidiary of"
    },
    {
        source: PartnerType$1.PERSON,
        target: PartnerType$1.COMPANY,
        relation: "is employee of",
        inverseRelation: "employs",
        role: "isEmployeeOf"
    },
    {
        source: PartnerType$1.COMPANY,
        target: PartnerType$1.COMPANY,
        relation: "is supplier of",
        inverseRelation: "has supplier",
        role: "isSupplierOf",
    },
];
/** @enum {string} */
var RelationRole = {
    HOLDING_OF: "isHoldingOf",
    EMPLOYEE_OF: "isEmployeeOf",
    SUPPLIER_OF: "isSupplierOf",
};
/** @type {?} */
var relationRoles = [];
for (var n$2 in RelationRole) {
    relationRoles.push(PartnerType$1[n$2]);
}
var RelationConfigService = /** @class */ (function () {
    function RelationConfigService() {
    }
    // -----------------------------------------------------------------------------------------------------
    // @ Utility Methods
    // -----------------------------------------------------------------------------------------------------
    /**
     *
     * @param type1
     * @param type2
     * @returns all relation configs where type1 -> type2 or type2 -> type1
     */
    // -----------------------------------------------------------------------------------------------------
    // @ Utility Methods
    // -----------------------------------------------------------------------------------------------------
    /**
     *
     * @param {?} type1
     * @param {?} type2
     * @return {?} all relation configs where type1 -> type2 or type2 -> type1
     */
    RelationConfigService.getRelationConfigsUndirected = 
    // -----------------------------------------------------------------------------------------------------
    // @ Utility Methods
    // -----------------------------------------------------------------------------------------------------
    /**
     *
     * @param {?} type1
     * @param {?} type2
     * @return {?} all relation configs where type1 -> type2 or type2 -> type1
     */
    function (type1, type2) {
        /** @type {?} */
        var _config = relationsConfig.filter(((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return (value.source === type1 && value.target === type2) ||
                (value.source === type2 && value.target === type1);
        })));
        return _config;
    };
    /**
     *
     * @param source
     * @param target
     * @returns all relation configs that exist from source type to target type
     */
    /**
     *
     * @param {?} source
     * @param {?} target
     * @return {?} all relation configs that exist from source type to target type
     */
    RelationConfigService.getRelationConfigsDirected = /**
     *
     * @param {?} source
     * @param {?} target
     * @return {?} all relation configs that exist from source type to target type
     */
    function (source, target) {
        /** @type {?} */
        var _relationConfig = relationsConfig.filter(((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return (value.source === source && value.target === target);
        })));
        return _relationConfig;
    };
    /**
     *
     * @param role
     * @returns the unique RelationConfig for a role
     */
    /**
     *
     * @param {?} role
     * @return {?} the unique RelationConfig for a role
     */
    RelationConfigService.getRelationConfigForRole = /**
     *
     * @param {?} role
     * @return {?} the unique RelationConfig for a role
     */
    function (role) {
        /** @type {?} */
        var _relationConfig = relationsConfig.filter((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return value.role === role; })).find((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x !== undefined; }));
        return _relationConfig;
    };
    /**
     *
     * @param rel relation
     * @param partnerId the partner that appears either as source or as target in rel
     * @returns returns the relation designation
     */
    /**
     *
     * @param {?} rel relation
     * @param {?} partnerId the partner that appears either as source or as target in rel
     * @return {?} returns the relation designation
     */
    RelationConfigService.getDisplayedRelation = /**
     *
     * @param {?} rel relation
     * @param {?} partnerId the partner that appears either as source or as target in rel
     * @return {?} returns the relation designation
     */
    function (rel, partnerId) {
        /** @type {?} */
        var config = this.getRelationConfigForRole(rel.role);
        return rel.sourcePartner.partnerId === partnerId ? config.relation : config.inverseRelation;
    };
    /**
     *
     * @param type
     * @returns all configurations including type either as source or target
     */
    /**
     *
     * @param {?} type
     * @return {?} all configurations including type either as source or target
     */
    RelationConfigService.getRelationConfigsIncludingType = /**
     *
     * @param {?} type
     * @return {?} all configurations including type either as source or target
     */
    function (type) {
        var e_1, _a;
        /** @type {?} */
        var configs = relationsConfig.filter((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return value.source === type || value.target === type; }));
        try {
            for (var configs_1 = __values(configs), configs_1_1 = configs_1.next(); !configs_1_1.done; configs_1_1 = configs_1.next()) {
                var config = configs_1_1.value;
                if (config.target === type) {
                    config.perspective = 'target';
                }
                else {
                    config.perspective = 'source';
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (configs_1_1 && !configs_1_1.done && (_a = configs_1.return)) _a.call(configs_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return configs;
    };
    /**
     *
     * @param type
     * @returns all configurations including type either source
     */
    /**
     *
     * @param {?} type
     * @return {?} all configurations including type either source
     */
    RelationConfigService.getRelationConfigsIncludingTypeAsSource = /**
     *
     * @param {?} type
     * @return {?} all configurations including type either source
     */
    function (type) {
        var e_2, _a;
        /** @type {?} */
        var res = _.cloneDeep((relationsConfig.filter((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return value.source === type; }))));
        try {
            for (var res_1 = __values(res), res_1_1 = res_1.next(); !res_1_1.done; res_1_1 = res_1.next()) {
                var val = res_1_1.value;
                val.perspective = 'source';
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (res_1_1 && !res_1_1.done && (_a = res_1.return)) _a.call(res_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return res;
    };
    /**
     *
     * @param type
     * @returns all configurations including type either source
     */
    /**
     *
     * @param {?} type
     * @return {?} all configurations including type either source
     */
    RelationConfigService.getRelationConfigsIncludingTypeAsTarget = /**
     *
     * @param {?} type
     * @return {?} all configurations including type either source
     */
    function (type) {
        var e_3, _a;
        /** @type {?} */
        var res = _.cloneDeep(relationsConfig.filter((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return value.target === type; })));
        try {
            for (var res_2 = __values(res), res_2_1 = res_2.next(); !res_2_1.done; res_2_1 = res_2.next()) {
                var val = res_2_1.value;
                val.perspective = 'target';
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (res_2_1 && !res_2_1.done && (_a = res_2.return)) _a.call(res_2);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return res;
    };
    return RelationConfigService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Billing <br/>
 * @record
 */
function Billing() { }
if (false) {
    /** @type {?|undefined} */
    Billing.prototype.bankAccount;
    /** @type {?|undefined} */
    Billing.prototype.invoiceText;
    /** @type {?|undefined} */
    Billing.prototype.notes;
    /** @type {?|undefined} */
    Billing.prototype.paymentConditions;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.ContactLog <br/>
 * @record
 */
function ContactLog() { }
if (false) {
    /** @type {?|undefined} */
    ContactLog.prototype.change;
    /**
     * 	values: email, phone<br/>
     * \@example email
     * @type {?|undefined}
     */
    ContactLog.prototype.communicationChannel;
    /** @type {?|undefined} */
    ContactLog.prototype.contactLogId;
    /** @type {?|undefined} */
    ContactLog.prototype.created;
    /**
     * @deprecated
     * @type {?|undefined}
     */
    ContactLog.prototype.dateRange;
    /** @type {?|undefined} */
    ContactLog.prototype.duration;
    /** @type {?|undefined} */
    ContactLog.prototype.info;
    /** @type {?|undefined} */
    ContactLog.prototype.location;
    /** @type {?|undefined} */
    ContactLog.prototype.notes;
    /** @type {?|undefined} */
    ContactLog.prototype.orgId;
    /** @type {?|undefined} */
    ContactLog.prototype.participants;
    /** @type {?|undefined} */
    ContactLog.prototype.projectId;
    /**
     * 	values: new, pending, done, archived<br/>
     * \@example new
     * @type {?|undefined}
     */
    ContactLog.prototype.status;
    /** @type {?|undefined} */
    ContactLog.prototype.taskId;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Participant <br/>
 * @record
 */
function Participant() { }
if (false) {
    /** @type {?|undefined} */
    Participant.prototype.participantId;
    /** @type {?|undefined} */
    Participant.prototype.role;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Partner <br/>
 * @record
 */
function Partner() { }
if (false) {
    /** @type {?|undefined} */
    Partner.prototype.billing;
    /** @type {?|undefined} */
    Partner.prototype.classification;
    /** @type {?|undefined} */
    Partner.prototype.displayName;
    /** @type {?|undefined} */
    Partner.prototype.jobDesc;
    /** @type {?|undefined} */
    Partner.prototype.masterContractAvailable;
    /** @type {?|undefined} */
    Partner.prototype.nda;
    /** @type {?|undefined} */
    Partner.prototype.orgId;
    /** @type {?|undefined} */
    Partner.prototype.partnerId;
    /**
     * 	values: person, company<br/>
     * \@example person
     * @type {?|undefined}
     */
    Partner.prototype.partnerType;
    /**
     * 	values: email, phone<br/>
     * \@example email
     * @type {?|undefined}
     */
    Partner.prototype.preferredCommunicationChannel;
    /**
     * 	values: active, inactive, blocked<br/>
     * @type {?|undefined}
     */
    Partner.prototype.status;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.PartnerInfo <br/>
 * @record
 */
function PartnerInfo() { }
if (false) {
    /** @type {?|undefined} */
    PartnerInfo.prototype.classification;
    /** @type {?|undefined} */
    PartnerInfo.prototype.companyName;
    /** @type {?|undefined} */
    PartnerInfo.prototype.email;
    /** @type {?|undefined} */
    PartnerInfo.prototype.firstName;
    /** @type {?|undefined} */
    PartnerInfo.prototype.lastName;
    /** @type {?|undefined} */
    PartnerInfo.prototype.partnerId;
    /** @type {?|undefined} */
    PartnerInfo.prototype.partnerType;
    /** @type {?|undefined} */
    PartnerInfo.prototype.shortName;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Relation <br/>
 * @record
 */
function Relation() { }
if (false) {
    /** @type {?|undefined} */
    Relation.prototype.change;
    /**
     * \@example Lead, Engineer
     * @type {?|undefined}
     */
    Relation.prototype.classifier;
    /** @type {?|undefined} */
    Relation.prototype.created;
    /** @type {?|undefined} */
    Relation.prototype.orgId;
    /** @type {?|undefined} */
    Relation.prototype.relationId;
    /**
     * 	values: customer, employee, employer<br/>
     * \@example customer
     * @type {?|undefined}
     */
    Relation.prototype.role;
    /** @type {?|undefined} */
    Relation.prototype.sourcePartner;
    /** @type {?|undefined} */
    Relation.prototype.targetPartner;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.domain.Reminder <br/>
 * @record
 */
function Reminder() { }
if (false) {
    /** @type {?|undefined} */
    Reminder.prototype.change;
    /**
     * 	values: email, phone<br/>
     * \@example email
     * @type {?|undefined}
     */
    Reminder.prototype.communicationChannel;
    /** @type {?|undefined} */
    Reminder.prototype.created;
    /** @type {?|undefined} */
    Reminder.prototype.dueDate;
    /** @type {?|undefined} */
    Reminder.prototype.notes;
    /** @type {?|undefined} */
    Reminder.prototype.orgId;
    /** @type {?|undefined} */
    Reminder.prototype.reminderId;
    /** @type {?|undefined} */
    Reminder.prototype.reminderPartnerId;
    /**
     * 	values: new, pending, done, archived<br/>
     * \@example new
     * @type {?|undefined}
     */
    Reminder.prototype.status;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.filter.PartnerFilter <br/>
 * @record
 */
function PartnerFilter() { }
if (false) {
    /** @type {?|undefined} */
    PartnerFilter.prototype.classification;
    /** @type {?|undefined} */
    PartnerFilter.prototype.companyName;
    /** @type {?|undefined} */
    PartnerFilter.prototype.email;
    /** @type {?|undefined} */
    PartnerFilter.prototype.firstName;
    /** @type {?|undefined} */
    PartnerFilter.prototype.lastName;
    /** @type {?|undefined} */
    PartnerFilter.prototype.mobile;
    /** @type {?|undefined} */
    PartnerFilter.prototype.partnerId;
    /** @type {?|undefined} */
    PartnerFilter.prototype.partnerType;
    /** @type {?|undefined} */
    PartnerFilter.prototype.phoneNumber;
    /** @type {?|undefined} */
    PartnerFilter.prototype.preferredCommunicationChannel;
    /** @type {?|undefined} */
    PartnerFilter.prototype.role;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.base.core.filter.ReminderFilter <br/>
 * @record
 */
function ReminderFilter() { }
if (false) {
    /** @type {?|undefined} */
    ReminderFilter.prototype.communicationChannel;
    /** @type {?|undefined} */
    ReminderFilter.prototype.dueDateRange;
    /** @type {?|undefined} */
    ReminderFilter.prototype.notes;
    /** @type {?|undefined} */
    ReminderFilter.prototype.reminderId;
    /** @type {?|undefined} */
    ReminderFilter.prototype.reminderPartnerId;
    /** @type {?|undefined} */
    ReminderFilter.prototype.status;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.partner.service.rest.ContactLogRest <br/>
 */
var ContactLogRest = /** @class */ (function () {
    function ContactLogRest(httpService) {
        this.httpService = httpService;
    }
    ContactLogRest.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ContactLogRest.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return ContactLogRest;
}());
if (false) {
    /** @type {?} */
    ContactLogRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.partner.service.rest.PartnerRest <br/>
 */
var PartnerRest = /** @class */ (function () {
    function PartnerRest(httpService) {
        this.httpService = httpService;
    }
    PartnerRest.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    PartnerRest.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return PartnerRest;
}());
if (false) {
    /** @type {?} */
    PartnerRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.partner.service.rest.RelationRest <br/>
 */
var RelationRest = /** @class */ (function () {
    function RelationRest(httpService) {
        this.httpService = httpService;
    }
    /**
     * @param {?} partnerId
     * @param {?} role
     * @param {?} traversalDir
     * @return {?}
     */
    RelationRest.prototype.traverseRelations = /**
     * @param {?} partnerId
     * @param {?} role
     * @param {?} traversalDir
     * @return {?}
     */
    function (partnerId, role, traversalDir) {
        var e_1, _a;
        /** @type {?} */
        var queryParamsList = [];
        queryParamsList.push({ name: 'partnerId', value: partnerId });
        queryParamsList.push({ name: 'role', value: role });
        queryParamsList.push({ name: 'traversalDir', value: traversalDir });
        /** @type {?} */
        var params = new HttpParams();
        try {
            for (var queryParamsList_1 = __values(queryParamsList), queryParamsList_1_1 = queryParamsList_1.next(); !queryParamsList_1_1.done; queryParamsList_1_1 = queryParamsList_1.next()) {
                var queryParam = queryParamsList_1_1.value;
                params = params.append(queryParam.name, queryParam.value);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (queryParamsList_1_1 && !queryParamsList_1_1.done && (_a = queryParamsList_1.return)) _a.call(queryParamsList_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return this.httpService.post('/relations/traverse', null, { params: params });
    };
    RelationRest.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RelationRest.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return RelationRest;
}());
if (false) {
    /** @type {?} */
    RelationRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.crm.partner.service.rest.ReminderRest <br/>
 */
var ReminderRest = /** @class */ (function () {
    function ReminderRest(httpService) {
        this.httpService = httpService;
    }
    ReminderRest.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ReminderRest.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return ReminderRest;
}());
if (false) {
    /** @type {?} */
    ReminderRest.prototype.httpService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@toDo * [ww] 'Account' => Partner
 * @deprecated
 * @record
 */
function PartnerAspect() { }
if (false) {
    /**
     * @param {?} filter
     * @return {?}
     */
    PartnerAspect.prototype.queryAccount = function (filter) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    PartnerAspect.prototype.loadAccount = function (id, shortName) { };
    /**
     * @param {?} partner
     * @return {?}
     */
    PartnerAspect.prototype.saveAccount = function (partner) { };
    /**
     * @param {?} id
     * @return {?}
     */
    PartnerAspect.prototype.deleteAccount = function (id) { };
    /**
     * @param {?} id
     * @param {?} shortName
     * @return {?}
     */
    PartnerAspect.prototype.newAccount = function (id, shortName) { };
    /**
     * @param {?} filter
     * @return {?}
     */
    PartnerAspect.prototype.export = function (filter) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// services
var CRMCoreModule = /** @class */ (function () {
    function CRMCoreModule() {
    }
    /**
     * @return {?}
     */
    CRMCoreModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: CRMCoreModule,
            providers: [
                AccountService, ContactLogService, RelationService, RelationConfigService
            ]
        };
    };
    CRMCoreModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        HttpClientModule,
                        TranslateModule.forChild()
                    ],
                    declarations: [],
                    exports: [],
                    providers: [],
                    entryComponents: [],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];
    return CRMCoreModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AccountService, AccountUtilities, AddressUtils, CRMCoreModule, ContactLogRest, ContactLogService, PartnerRest, PartnerType, RelationConfigService, RelationRest, RelationRole, RelationService, ReminderRest, partnerTypes, relationRoles, relationsConfig, sortByCompanyName, sortByLastName, withId, withType, PartnerType$1 as ɵa };
//# sourceMappingURL=yukawa-chain-crm-angular-core.js.map
